unit fmFileRights;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFileAccessForm = class(TForm)
    BnOK: TButton;
    BnCancel: TButton;
    CBxBit20: TCheckBox;
    CBxBit18: TCheckBox;
    CBxBit16: TCheckBox;
    CBxBit19: TCheckBox;
    CBxBit17: TCheckBox;
    CBxBit15: TCheckBox;
    CBxBit13: TCheckBox;
    CBxBit11: TCheckBox;
    CBxBit9: TCheckBox;
    CBxBit7: TCheckBox;
    CBxBit5: TCheckBox;
    CBxBit3: TCheckBox;
    CBxBit1: TCheckBox;
    CBxBit14: TCheckBox;
    CBxBit12: TCheckBox;
    CBxBit10: TCheckBox;
    CBxBit8: TCheckBox;
    CBxBit6: TCheckBox;
    CBxBit4: TCheckBox;
    CBxBit2: TCheckBox;
    CBxBit0: TCheckBox;
    Bevel1: TBevel;
    Label1: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    LbMask: TLabel;
    procedure CBxBitClick(Sender: TObject);
  private
    { Private declarations }
    _AccessMask: DWORD;
    procedure SetAccessMask(Value: DWORD);
  public
    { Public declarations }
    property AccessMask: DWORD read _AccessMask write SetAccessMask;
    function AccessMaskText: String;
  end;

var
  FileAccessForm: TFileAccessForm;

implementation

{$R *.DFM}

procedure TFileAccessForm.SetAccessMask(Value: DWORD);
var i: Integer;
    Ctl: TControl;
    CBx: TCheckBox;
begin
    _AccessMask:=0;
    for i:=0 to ControlCount-1 do
    begin
        Ctl:=Controls[i];
        if not (Ctl is TCheckBox) then continue;
        CBx:=Ctl as TCheckBox;
        CBx.Checked:=(CBx.Tag and Value) <> 0;
        if CBx.Checked then _AccessMask:=_AccessMask or DWORD(CBx.Tag);
    end;
    LbMask.Caption:='$'+IntToHex(AccessMask,8);
end;

procedure TFileAccessForm.CBxBitClick(Sender: TObject);
begin
    with Sender as TCheckBox do
    begin
        if Checked then
            _AccessMask:=_AccessMask or DWORD(Tag)
        else
            _AccessMask:=_AccessMask and not DWORD(Tag);
    end;
    LbMask.Caption:='$'+IntToHex(AccessMask,8);
end;

function TFileAccessForm.AccessMaskText: String;
var i: Integer;
    Ctl: TControl;
    CBx: TCheckBox;
    S: String;
begin
    result:='';
    for i:=0 to ControlCount-1 do
    begin
        Ctl:=Controls[i];
        if not (Ctl is TCheckBox) then continue;
        CBx:=Ctl as TCheckBox;
        if not CBx.Checked then continue;
        S:=CBx.Caption;
        Delete(S,1,9);
        result:=result+S+'; ';
    end;
end;

end.
